<table
  mat-table
  multiTemplateDataRows
  [dataSource]="testSuiteDataSource"
  matSort
  class="test-suite-table border-grey-300 mt-1"
  aria-label="Test-suites selection table"
>
  <ng-container matColumnDef="tsCheckbox">
    <th
      mat-header-cell
      *matHeaderCellDef
      (click)="$event.stopPropagation()"
      (keydown)="$event.stopPropagation()"
    ></th>

    <td mat-cell *matCellDef="let i = dataIndex">
      <div
        (click)="$event.stopPropagation()"
        (keydown)="$event.stopPropagation()"
      >
        <mat-checkbox
          [checked]="suiteCheckboxes[i].selected"
          [indeterminate]="partiallyComplete[i]()"
          (change)="onCheckboxChange($event.checked, i)"
          [disabled]="suiteCheckboxes[i].disabled"
        >
        </mat-checkbox>
      </div>
    </td>
  </ng-container>

  @for (column of testSuiteColumns.slice(1); track column) {
    @if (column !== "info") {
      <ng-container matColumnDef="{{ column }}">
        <th
          mat-header-cell
          *matHeaderCellDef
          mat-sort-header
          sortActionDescription="Sort by Test Suite {{ column }}"
        >
          {{ mapProp2Column.get(column) | titlecase }}
        </th>
        <td mat-cell *matCellDef="let testSuite">
          @if (column === "testCasesResult") {
            <div>
              <app-test-result-bar
                [resultNotExecuted]="testSuite.resultNotExecuted"
                [resultError]="testSuite.resultError"
                [resultSuccess]="testSuite.resultSuccess"
              ></app-test-result-bar>

              @if (testSuite.resultSuccess! > 0 || testSuite.resultError! > 0) {
                <div class="d-flex align-items-center mb-0 mt-4px">
                  {{ testSuite.resultSuccess | percent: "1.0-1" }}
                  <mat-icon class="check-circle-icon text-success">
                    check_circle
                  </mat-icon>

                  {{ testSuite.resultError | percent: "1.0-1" }}
                  <mat-icon class="cancel-icon text-error">cancel</mat-icon>

                  {{ testSuite.resultNotExecuted | percent: "1.0-1" }}
                  <mat-icon class="block-icon text-grey-500">block</mat-icon>
                </div>
              }
            </div>
          } @else {
            {{
              column === "lastUpdate"
                ? (testSuite[column] | date: "dd/M/yyyy")
                : testSuite[column]
            }}
          }
        </td>
      </ng-container>
    } @else {
      <ng-container matColumnDef="{{ column }}">
        <th mat-header-cell *matHeaderCellDef></th>
        <td
          mat-cell
          *matCellDef="let testSuite"
          (click)="$event.stopPropagation()"
          (keydown)="$event.stopPropagation()"
        >
          <button mat-icon-button color="primary" disabled>
            <mat-icon class="material-icons-outlined">info</mat-icon>
          </button>
        </td>
      </ng-container>
    }
  }

  <ng-container matColumnDef="expand">
    <th mat-header-cell *matHeaderCellDef aria-label="row actions">&nbsp;</th>
    <td mat-cell *matCellDef="let testSuite">
      <button
        mat-icon-button
        aria-label="expand row"
        (click)="
          expandedElement = expandedElement === testSuite ? null : testSuite;
          $event.stopPropagation()
        "
      >
        @if (expandedElement === testSuite) {
          <mat-icon>keyboard_arrow_up</mat-icon>
        } @else {
          <mat-icon>keyboard_arrow_down</mat-icon>
        }
      </button>
    </td>
  </ng-container>

  <!-- Expanded Content Column - The detail row is made up of this one column that spans across all columns -->
  <ng-container matColumnDef="expandedDetail">
    <td
      mat-cell
      *matCellDef="let testSuite; let i = dataIndex"
      [attr.colspan]="testSuiteColumnsWithExpand.length"
    >
      <div
        class="test-suite-detail"
        [@detailExpand]="
          testSuite === expandedElement ? 'expanded' : 'collapsed'
        "
      >
        <table
          mat-table
          [dataSource]="testCaseDataSources[i]"
          class="test-case-table border-grey-300"
          aria-label="Test-suite test-cases table"
        >
          <ng-container matColumnDef="tcCheckbox">
            <th mat-header-cell *matHeaderCellDef></th>

            <td mat-cell *matCellDef="let testCase">
              <div
                (click)="$event.stopPropagation()"
                (keydown)="$event.stopPropagation()"
              >
                @for (
                  tc of testCaseDataSources[i].data;
                  track tc;
                  let j = $index
                ) {
                  @if (tc === testCase) {
                    <mat-checkbox
                      [checked]="
                        suiteCheckboxes[i].children?.length! > 0
                          ? suiteCheckboxes[i].children![j].selected
                          : undefined
                      "
                      (change)="onCheckboxChange($event.checked, i, j)"
                      [disabled]="
                        suiteCheckboxes[i].children?.length! > 0
                          ? suiteCheckboxes[i].children![j].disabled
                          : false
                      "
                    >
                    </mat-checkbox>
                  }
                }
              </div>
            </td>
          </ng-container>

          <ng-container matColumnDef="name">
            <th mat-header-cell *matHeaderCellDef>Test Case</th>
            <td mat-cell *matCellDef="let testCase">{{ testCase.name }}</td>
          </ng-container>

          <ng-container matColumnDef="description">
            <th mat-header-cell *matHeaderCellDef>Description</th>
            <td mat-cell *matCellDef="let testCase">
              {{ testCase.description }}
            </td>
          </ng-container>

          <ng-container matColumnDef="status">
            <th mat-header-cell *matHeaderCellDef>Status</th>
            <td mat-cell *matCellDef="let testCase">
              <div class="slabs-comp ec-chips-theme">
                <mat-chip
                  highlighted
                  class="slabs-chip"
                  [color]="status2ChipColor.get(testCase.status.toUpperCase())"
                >
                  {{ testCase.status }}
                </mat-chip>
              </div>
            </td>
          </ng-container>

          <ng-container matColumnDef="info">
            <th mat-header-cell *matHeaderCellDef></th>
            <td
              mat-cell
              *matCellDef="let testCase"
              (click)="$event.stopPropagation()"
              (keydown)="$event.stopPropagation()"
            >
              <button
                mat-icon-button
                color="primary"
                (click)="showTestCaseInfo(testCase)"
              >
                <mat-icon class="material-icons-outlined">info</mat-icon>
              </button>
            </td>
          </ng-container>

          <tr mat-header-row *matHeaderRowDef="testCaseColumns"></tr>
          <tr
            mat-row
            *matRowDef="let row; columns: testCaseColumns"
            class="test-case-row"
          ></tr>
        </table>
      </div>
    </td>
  </ng-container>

  <tr mat-header-row *matHeaderRowDef="testSuiteColumnsWithExpand"></tr>
  <tr
    mat-row
    *matRowDef="let testSuite; columns: testSuiteColumnsWithExpand"
    class="test-suite-row"
    [class.expanded-row]="expandedElement === testSuite"
    (click)="expandedElement = expandedElement === testSuite ? null : testSuite"
    (keydown)="
      expandedElement = expandedElement === testSuite ? null : testSuite
    "
  ></tr>

  <tr
    mat-row
    *matRowDef="let row; columns: ['expandedDetail']"
    class="detail-row"
  ></tr>
</table>
